#ifndef gemc_MAINGUI_H
#define gemc_MAINGUI_H

// %%%%%%%%%%
// Qt headers
// %%%%%%%%%%
#include <QComboBox>
#include <QGroupBox>
#include <QLCDNumber>
#include <QLineEdit>
#include <QObject>
#include <QPushButton>
#include <QSlider>
#include <QVBoxLayout>
#include <QWidget>

#include <QListWidgetItem>
#include <QStackedWidget>

// %%%%%%%%%%
// G4 headers
// %%%%%%%%%%
#include "G4Material.hh"
#include "G4RunManager.hh"
#include "G4VisManager.hh"
#include "G4UImanager.hh"

// %%%%%%%%%%%%%
// gemc headers
// %%%%%%%%%%%%%
#include "detector_tree.h"
#include "run_control.h"
#include "camera_control.h"
#include "infos.h"
#include "usage.h"

// %%%%%%%%%%%%%%%%
// Class definition
// %%%%%%%%%%%%%%%%
class gemcMainWidget : public QWidget
{
	// metaobject required for non-qt slots
	Q_OBJECT
	
	public:
		gemcMainWidget(G4RunManager*, G4VisManager*, gemc_opts*);
		~gemcMainWidget();
		
		map<string, detector> *Hall_Map;
		map<string, G4Material*> *MMats;
		gemc_opts *gemcOpt;
		
	private:
		
		// The timer will periodically update theta_hall, phi_hall if they're changed with the mouse
		//    QTimer *timer ;
		
		// passing G4 managers to QT so we can delete them when QT quits
		// and can access directly the UImanager
		G4RunManager *runManager;
		G4VisManager *visManager;
		G4UImanager  *UImanager;
		
		detector_tree *DTree;
		
	private slots:
		
		// Command Box
		//    void RunManualCommand();
		//
		//    void beamOn();
		
		
		// Other GUIs
		void  Build_DTree();
		
	private:
		void createIcons();
		
		QListWidget *contentsWidget;
		QStackedWidget *pagesWidget;
		QColor i_default;
		QColor i_hovered;
		
	public slots:
		void changePage(QListWidgetItem *current, QListWidgetItem *previous);
		void change_background(QListWidgetItem*);
		
};

#endif



