// %%%%%%%%%%%%%
// gemc headers
// %%%%%%%%%%%%%

#include "MSteppingAction.h"

MSteppingAction::MSteppingAction(gemc_opts Opt)
{
  gemcOpt = Opt;
  Energy_cut = gemcOpt.args["ENERGY_CUT"].arg; 
  max_x_pos  = gemcOpt.args["MAX_X_POS"].arg; 
  max_y_pos  = gemcOpt.args["MAX_Y_POS"].arg; 
  max_z_pos  = gemcOpt.args["MAX_Z_POS"].arg; 
}
MSteppingAction::~MSteppingAction(){}


void MSteppingAction::UserSteppingAction(const G4Step* aStep)
{
	
	G4ThreeVector   pos  = aStep->GetPostStepPoint()->GetPosition();     ///< Global Coordinates of interaction
	G4Track* track       = aStep->GetTrack();
	
	if(fabs(pos.x()) > max_x_pos || 
	   fabs(pos.y()) > max_y_pos || 
		 fabs(pos.z()) > max_z_pos ) track->SetTrackStatus(fStopAndKill);   ///< Killing track if outside of interest region

	if(track->GetKineticEnergy() < Energy_cut ){
		track->SetTrackStatus(fStopAndKill); 
	}

}

